if not FZeroKart then rawset(_G, "FZeroKart", {}) else return end


local FRACUNIT = FRACUNIT
local TICRATE = TICRATE

FZeroKart.deadPlayers = {}
FZeroKart.everyoneDeadTimer = 0
FZeroKart.SuperBoostMax = 3500

FZeroKart.Active = CV_RegisterVar{
	name = "fzero_enabled",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}

FZeroKart.InstaDeath = CV_RegisterVar{
	name = "fzero_instadeath",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}

FZeroKart.HudText = CV_RegisterVar{
	name = "fzero_hudtext",
	defaultvalue = "Off",
	PossibleValue = CV_OnOff
}

FZeroKart.SBDebug = CV_RegisterVar{
	name = "fzero_sbdebug",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}

FZeroKart.PlayerCount = function()
	local count = 0
	
	for p in players.iterate
		if p.spectator then continue end
		count = $+1
	end
	
	return count
end


FZeroKart.PlayerInit = function(p)
	p.fzerokart = {
		energy = 1000,
		energy_max = 1000,
		energy_lag = 1000,
		energy_bonus = 0,
		death_timer = 0,
		spin_immune_timer = 0,
		bumper_timer = 0,
		bumper = nil,
		kills = 0,
		heal_cooldown = 0,
		healthinit = nil,
		boost_cooldown = 0,
		super_boost = 0,
		super_boostdecay = 0,
		super_boostlag = 0,
		lastz = 0,
		lasttrick = 0,
		racefinish = nil,
		raceeval = nil,
		lastlap = 0,
		finishsound = nil
	}
end

FZeroKart.DamagePlayer = function(p, dmg, source, force, nonfatal)
	if not FZeroKart.Active.value then return end
	 
	if leveltime <= 236 then return end
	
	if not (type(p) == "userdata") then error("arg1 expected type userdata, got " .. type(p), 2) end
	if not (p and p.valid) then error("arg1 is not a valid target", 2) end
	if not (type(dmg) == "number") then error("arg2 expected type number, got " .. type(dmg), 2) end
	if source and not (type(source) == "userdata" or type(source) == "table") then
		error("arg3 expected type userdata or table, got " .. type(dmg), 2)
	end

	if not p.fzerokart then FZeroKart.PlayerInit(p) end
	if p.fzerokart.death_timer > 0 then return end
	if p.exiting then return end
	if p.fzerokart.super_booston then return end

	-- I want the CRUNCH
	S_StartSound(p.mo, sfx_s1ac)
	S_StartSound(p.mo, sfx_s1ac)
	S_StartSound(p.mo, sfx_s1ac)
	
	if G_BattleGametype() then
		dmg = $*2
	end

	if (dmg >= p.fzerokart.energy and not nonfatal) or force then
		if p.pflags & PF_TIMEOVER then return end
		
		FZeroKart.deadPlayers[#FZeroKart.deadPlayers+1] = {p, source, dmg, force}
	else
		if nonfatal and dmg >= p.fzerokart.energy then
			p.fzerokart.energy = 1
		else
			p.fzerokart.energy = $ - dmg
		end
	end
	
end

FZeroKart.HealPlayer = function(p, heal)
	if not FZeroKart.Active.value then return end
	 
	if leveltime <= 236 then return end
	
	if not (type(p) == "userdata") then error("arg1 expected type userdata, got " .. type(p), 2) end
	if not (p and p.valid) then error("arg1 is not a valid target", 2) end
	if not (type(heal) == "number") then error("arg2 expected type number, got " .. type(heal), 2) end

	if not p.fzerokart then FZeroKart.PlayerInit(p) end

	if p.fzerokart.death_timer > 0 then return end
	if p.exiting then return end

	local wt = p.kartweight
	local spd = p.kartspeed
	
	local fuel_econ = ((26*4 + (spd - 1) + wt*2)*8)
	local killbonus = fuel_econ/5
	local enmax = min(p.fzerokart.energy_max + (killbonus*p.fzerokart.kills), p.fzerokart.energy_max*2)
	p.fzerokart.energy = min($ + heal, enmax)
end

FZeroKart.KillPlayer = function(p)
	if not FZeroKart.Active.value then return end
	 
	if not (p and p.valid and p.mo) then return end

	p.lives = 0
	p.pflags = $ | PF_TIMEOVER
	p.kartstuff[k_position] = FZeroKart.PlayerCount()
	--P_RestoreMusic(p)
	S_ChangeMusic("KRFAIL", true, p)
	P_DamageMobj(p.mo, nil, nil, 10000)

	if p.mo and p.mo.valid then
		p.mo.momx = 0
		p.mo.momy = 0
		p.mo.momz = 0
	end

	p.kartstuff[k_sneakertimer] = 0
end

local PG_STARTWINGVEL			= 48*FRACUNIT
local PG_STARTWINGSTOREDVEL		= 5*FRACUNIT
FZeroKart.DoBoost = function(p)
	if not FZeroKart.Active.value then return end
	 
	if leveltime <= 236 then return end
	local boost_taunt = 1
	
	if p.fzerokart.super_boost == FZeroKart.SuperBoostMax then
		boost_taunt = 0
	end
	
	K_DoSneaker(p, boost_taunt)
	
	if not boost_taunt then
		K_PlayPowerGloatSound(p.mo)
	end

	if (p.fzerokart.super_boost == FZeroKart.SuperBoostMax 
	or FZeroKart.SBDebug.value) then
		p.fzerokart.super_booston = true
		jglider.resetGliderValues(p.mo)
		p.mo.paragliding = true
		jglider.createParaglider(p.mo)
		jglider.initParaglider(p.mo)
		
		p.mo.storedGlideMomz 		= abs(p.mo.momz) + FixedMul(PG_STARTWINGSTOREDVEL, mapobjectscale)
		p.mo.targetFallRt 			= abs(p.mo.momz) + FixedMul(PG_STARTWINGVEL, mapobjectscale)
		p.mo.startFallVel			= max(p.mo.momz, 0)
		p.mo.glideFinBuffer			= 0

		local boostdiff = (FZeroKart.PlayerCount() - p.kartstuff[k_position])
		local decay = min(14 + (boostdiff*2), 35)

		p.fzerokart.super_boostdecay = decay
	else
		p.fzerokart.boost_on = 1
		p.kartstuff[k_sneakertimer] = $ + 70
		
		-- More weight/speed means less fuel econ, so Omega has THE worst boost econ
		local wt = p.kartweight
		local spd = p.kartspeed
	
		local fuel_econ = ((26*4 + (spd - 1) + ((wt-1)*2))*8)

		local dmg = FixedInt(FixedDiv(fuel_econ*FRACUNIT, 4*FRACUNIT))
		p.fzerokart.energy = max($ - dmg, 1)
	end
end

FZeroKart.GainSuperBoost = function(p, num)
	if not FZeroKart.Active.value then return end
	if leveltime <= 236 then return end

	if p.playerstate ~= PST_LIVE
	or p.kartstuff[k_respawn] > 0
	or (p.exiting or (p.pflags & PF_TIMEOVER)) then
		return
	end

	p.fzerokart.super_boost = min($ + num, FZeroKart.SuperBoostMax)
end

FZeroKart.NetVars = function(net)
	FZeroKart.deadPlayers = net($)
	FZeroKart.everyoneDeadTimer = net($)
	FZeroKart.SuperBoostMax = net($)
end
addHook("NetVars", FZeroKart.NetVars)

FZeroKart.GameRefresh = function()
	for p in players.iterate
		if not (p and p.valid) then continue end
		
		FZeroKart.PlayerInit(p)
		--print("EN: "..p.fzerokart.energy)
		--print("EN MAX:"..p.fzerokart.energy_max)
		--print("PDT: "..p.fzerokart.death_timer)
	end

	FZeroKart.everyoneDeadTimer = 0
	-- Spawn safe rank display holder here
end

FZeroKart.ShouldHurt = function(p)
	if not FZeroKart.Active.value then return end
	 
	return not (p.nspintimer or p.fzerokart.healing or p.powers[pw_flashing] > 0 or p.kartstuff[k_squishedtimer] > 0 or p.kartstuff[k_spinouttimer] > 0
		or p.kartstuff[k_invincibilitytimer] > 0 or (p.kartstuff[k_growshrinktimer] > 0 or (HugeQuest and p.hugequest.huge > 0)) or p.kartstuff[k_hyudorotimer] > 0
		or (G_BattleGametype() and ((p.kartstuff[k_bumper] <= 0 and p.kartstuff[k_comebacktimer]) or p.kartstuff[k_comebackmode] == 1)))
end

FZeroKart.HitfeedInfo = function(p)
	if p and p.valid and p.mo and p.mo.valid then
		return {{p.name, p.mo.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
	else
		return {{}, {}}
	end
end

-- Create Super Boost Glider table here
FZeroKart.Glider = {}

FZeroKart.Init = true