local edt = FZeroKart.everyoneDeadTimer
local BT_ATTACK_DOWN = 1<<8
local hold_window = 10

FZeroKart.PlayerCmd = function(p, cmd)
	if not FZeroKart.Active.value then return end
	 
	if not p.fzerokart then return end
	if not (p.mo and p.mo.valid) then return end
	if (leveltime < 6*TICRATE + (3*TICRATE/4)) then return end -- No boosting before the race!
	if (p.exiting or (p.pflags & PF_TIMEOVER)) then return end -- No boosting after the race!
	if (p.kartstuff[k_spinouttimer]) then return end -- No cheating during spinout!
	
	if (cmd.buttons & BT_ATTACK and not p.fzerokart.buttontime) then
		--print("Button Held")
		cmd.buttons = $ | BT_ATTACK_DOWN
	elseif (not (cmd.buttons & BT_ATTACK or cmd.buttons & BT_ATTACK_DOWN) and p.fzerokart.buttonhold) then
		if (leveltime - p.fzerokart.buttonhold < hold_window) then
			--print("Button released early")
			cmd.buttons = $ | BT_ATTACK
		end
	end
	
	if (cmd.buttons & BT_ATTACK_DOWN) then
		cmd.buttons = $ & ~BT_ATTACK
	end
end
addHook("PlayerCmd", FZeroKart.PlayerCmd)

FZeroKart.PlayerThink = function(p)
	if not p.fzerokart then
		FZeroKart.PlayerInit(p)
		p.fzerokart.healthinit = nil
	end
	
	p.fzerokart.lastspeed = $ or -1
	p.fzerokart.lastweight = $ or -1
	p.fzerokart.lastskin = $ or -1

	if p.spectator then return end
	
	if not FZeroKart.Active.value then return end
		
	if (p.kartspeed ~= p.fzerokart.lastspeed
	or p.kartweight ~= p.fzerokart.lastweight
	or p.mo.skin ~= p.fzerokart.lastskin) then
		p.fzerokart.healthinit = nil
	end
	
	p.marescore = p.fzerokart.energy
	p.kartstuff[k_bumper] = 3

	-- Initializing Energy values
	if not p.fzerokart.healthinit then
		local wt = p.kartweight
		local spd = p.kartspeed
	
		local fuel_econ = ((26*4 + (spd - 1) + wt*2)*8)
		local killbonus = fuel_econ/5
			
		local enmax1 = min(p.fzerokart.energy_max + (p.fzerokart.kills*killbonus), p.fzerokart.energy_max*2)
		--print(enmax)
		local percent = FixedDiv(p.fzerokart.energy*FRACUNIT, enmax1*FRACUNIT)
		--print(percent/FRACUNIT)
		p.fzerokart.energy_max = 1000 + (((p.kartspeed-5)+(p.kartweight-5))*25)
		local enmax2 = min(p.fzerokart.energy_max + (p.fzerokart.kills*killbonus), p.fzerokart.energy_max*2)
		--print(p.fzerokart.energy_max)
		p.fzerokart.energy = FixedInt(FixedRound(FixedMul(enmax2*FRACUNIT, percent)))
		--print(p.fzerokart.energy)
		p.fzerokart.healthinit = true
	end
	----------------------------------------------

	-- Tutorial message!
	if leveltime >= 95
	and not p.fzerokart_tutorial then
		chatprintf(p,"*Press \137Item \128to \130Spin \128- briefly hold it to \132Boost\128!")
		p.fzerokart_tutorial = true
	end
	-- Item Box interactions
	if p.kartstuff[k_itemroulette] then
		p.kartstuff[k_itemroulette] = 0
		local spd = max(0, 9 - p.kartspeed)
		local wt = max(0, 9 - p.kartweight)
		local bonus_factor = FixedDiv(FRACUNIT, 2*FRACUNIT)
		local heal_scale = FixedMul(FixedDiv(bonus_factor, 16*FRACUNIT), (spd + wt)*FRACUNIT)
		local heal_bonus = FixedInt(FixedMul(200*FRACUNIT, heal_scale))
		FZeroKart.HealPlayer(p, 200 + heal_bonus)
		p.fzerokart.heal_cooldown = 35
		p.fzerokart.heal_anim = TICRATE/2
	end
	
	if p.kartstuff[k_itemtype] then -- LMAO item spawners
		local spd = max(0, 9 - p.kartspeed)
		local wt = max(0, 9 - p.kartweight)
		local bonus_factor = FixedDiv(FRACUNIT, 2*FRACUNIT)
		local heal_scale = FixedMul(FixedDiv(bonus_factor, 16*FRACUNIT), (spd + wt)*FRACUNIT)
		local heal_bonus = FixedInt(FixedMul(100*FRACUNIT, heal_scale))
		FZeroKart.HealPlayer(p, 100 + heal_bonus)
		K_StripItems(p)
	end
	--------------------------------------------------

	-- Fuck the air speed cap, we have vertical air control
	if not P_IsObjectOnGround(p.mo) then
		if p.lastspeed ~= nil then
			if p.speed >= 75*mapobjectscale then
				p.speed = min(p.lastspeed, 100*mapobjectscale)
			end
		end
	end
	---------------------------------------------------
	
	-- YOU GOT BOOST POWER!
	if leveltime >= 236 + 10*TICRATE
	and not (p.pflags & PF_TIMEOVER)
	and not p.fzboost then
		S_StartSound(nil, sfx_fzbst, p)
		p.fzboost = true
	elseif leveltime < 236 + 10*TICRATE 
		p.fzboost = nil
	end
	------------------------------------------------

	-- Hold input check
	if (p.cmd.buttons & BT_ATTACK_DOWN and not p.fzerokart.buttonhold) then
		p.fzerokart.buttonhold = leveltime
		--print("Button held at: "..p.fzerokart.buttonhold)
	elseif (not (p.cmd.buttons & BT_ATTACK_DOWN) and p.fzerokart.buttonhold) then
		p.fzerokart.buttontime = leveltime - p.fzerokart.buttonhold
		p.fzerokart.buttonhold = nil
	end
	-------------------------------------------------------

	-- Button held, TIME FOR FAST
	if (p.fzerokart.buttonhold 
	and leveltime - p.fzerokart.buttonhold >= 10
	and leveltime - p.fzerokart.buttonhold <= 40) -- Buffering boost from the air
	and P_IsObjectOnGround(p.mo)
	and not (p.fzerokart.boost_on or p.fzerokart.super_booston)
	and leveltime >= 236 + 10*TICRATE
	and (p.fzerokart.energy > 1 or p.fzerokart.super_boost == FZeroKart.SuperBoostMax) then
		FZeroKart.DoBoost(p)
	end
	----------------------------------------

	-----Top Speed Bonus-----
	local wt = (p.kartweight - 1)
	local tspdbonus = FixedDiv(FRACUNIT, 8*FRACUNIT)
	local scaledbonus = FixedMul(FixedDiv(tspdbonus, 8*FRACUNIT), wt*FRACUNIT)
	p.kartstuff[k_speedboost] = max($, scaledbonus)
	--print("Speed Boost: ".. p.kartstuff[k_speedboost])
	----------------------------------

	-- Calculating Boost Strength (B.POWR)
	local basesneakerbonus = FRACUNIT/2
	local basedriftbonus = FRACUNIT/4
	
	if p.kartstuff[k_driftboost] then
		p.kartstuff[k_speedboost] = max($, scaledbonus + basedriftbonus)
	end
	if p.kartstuff[k_sneakertimer]
	and (p.fzerokart.boost_on or p.fzerokart.super_booston) then
		local accel = max(0, 9 - p.kartspeed)
		local weight = max(0, 9 - p.kartweight)
		local bonus_factor = FixedDiv(FRACUNIT, 10*FRACUNIT)
		local base_boost = p.fzerokart.super_booston and 3*FRACUNIT/5 or basesneakerbonus
		local boost_strength = base_boost + FixedMul(FixedDiv(bonus_factor, 16*FRACUNIT), (accel*FRACUNIT + weight*FRACUNIT))
		if p.kartstuff[k_driftboost] then
			p.kartstuff[k_speedboost] = max($, scaledbonus + boost_strength + (2*basedriftbonus/5))
		else
			p.kartstuff[k_speedboost] = max($, scaledbonus + boost_strength)
		end

		--Hard cap at +75%
		p.kartstuff[k_speedboost] = min($, 3*FRACUNIT/4)
	end
	--------------------------------------------

	if p.fzerokart.buttontime then
		p.fzerokart.buttontime = nil
	end
	
	-- Boost Sector/Pit Zone Healing
	if p.kartstuff[k_floorboost] > 0 
	or p.mo.recharge then
		p.fzerokart.healing = true
		local spd = max(0, 9-p.kartspeed)
		local wt = max(0, 9-p.kartweight)
		local bonus_factor = FixedDiv(3*FRACUNIT, 5*FRACUNIT)
		local heal_scale = FixedMul(FixedDiv(bonus_factor, 16*FRACUNIT), (spd + wt)*FRACUNIT)
		local heal_bonus = FixedInt(FixedMul(10*FRACUNIT, heal_scale))
		
		-- Recreate Marsh recharge vfx
		if not p.mo.recharge then
			p.fzerokart.heal_anim = TICRATE
		end

		FZeroKart.HealPlayer(p, 10 + heal_bonus)
	else
		p.fzerokart.healing = nil
	end
	
	p.fzerokart.heal_cooldown = max($ - 1, 0)
	p.fzerokart.spin_immune_timer = max($ - 1, 0)
	if p.fzerokart.heal_anim then
		p.fzerokart.heal_anim = max($ - 1, 0)
		
		if not (leveltime%6) then
			for i = 0, 7 do
				local newangle = FixedAngle(((360/8)*i)*FRACUNIT)
				local newx = p.mo.x + P_ReturnThrustX(p.mo, newangle, 31*p.mo.scale)
				local newy = p.mo.y + P_ReturnThrustY(p.mo, newangle, 31*p.mo.scale)
				local newz

				if (p.mo.eflags & MFE_VERTICALFLIP)
					newz = p.mo.z + p.mo.height
				else
					newz = p.mo.z
				end
				local ringMo = P_SpawnMobj(newx, newy, newz, MT_DEZLASER)
				if (p.mo.eflags & MFE_VERTICALFLIP)
					ringMo.eflags = $|MFE_VERTICALFLIP
				end
				ringMo.target = p.mo
				ringMo.fzeroheal = true --differentiates itself in the mobjthinker
				ringMo.angle = newangle+ANGLE_90
				ringMo.momz = (8*p.mo.scale) * P_MobjFlip(p.mo)			
			end
		end
	else
		p.fzerokart.heal_anim = nil
	end
	-----------------------------------------------------

	-- EN Max Calc
	local wt = p.kartweight
	local spd = p.kartspeed
	
	local fuel_econ = ((26*4 + (spd - 1) + wt*2)*8)
	local killbonus = fuel_econ/5
	local enmax = min(p.fzerokart.energy_max + (killbonus*p.fzerokart.kills), p.fzerokart.energy_max*2)
	p.fzerokart.energy = min($, enmax)
	-------------------------------------------------

	if not p.kartstuff[k_sneakertimer] then
		if p.fzerokart.boost_on then
			p.fzerokart.boost_on = nil
		end
	end
	
	-- Super Boost: ON
	if p.fzerokart.super_boost == FZeroKart.SuperBoostMax
	and not p.fzerokart.super_boostready then
		S_StartSound(nil, sfx_sbrdy, p)
		p.fzerokart.super_boostready = true
	end
	
	
	if p.fzerokart.super_booston then
		p.fzerokart.super_boost = max($ - p.fzerokart.super_boostdecay, 0)
		p.kartstuff[k_sneakertimer] = 2
		
		if not p.fzerokart.super_boost then
			p.fzerokart.super_booston = nil
			p.fzerokart.forcelanding = true
			p.speed = min($, 75*mapobjectscale - 1)
			if p.fzerokart.super_boostready then
				p.fzerokart.super_boostready = nil
			end
		end
	end
	
	if (not p.fzerokart.super_booston)
	and p.fzerokart.forcelanding
	and P_IsObjectOnGround(p.mo) then
		p.fzerokart.forcelanding = nil
	end

	if p.fzerokart.bumper_timer then
		p.fzerokart.bumper_timer = max($-1, 0)
		--print(p.name.." bumper timer: "..p.fzerokart.bumper_timer/TICRATE)
	else
		p.fzerokart.bumper = nil
	end
	
	-- Gain Super Boost meter if not in 1st; scales with player count
	if not p.fzerokart.super_booston
	and G_RaceGametype() then
		if FZeroKart.SBDebug.value then
			p.fzerokart.super_boost = FZeroKart.SuperBoostMax
		elseif (leveltime >= 236 + 10*TICRATE
		and p.fzerokart.super_boost < FZeroKart.SuperBoostMax
		and not p.mo.paragliding
		and not (leveltime%3)) then
			local pdis = 0
			if (p.mo and p.mo.valid) then
				local playerMoList = {}
				for q in players.iterate do
					if not (q.mo and q.mo.valid) then continue end
					playerMoList[q.kartstuff[k_position]] = q.mo
				end
				local toposition = p.kartstuff[k_position] - 1
				while toposition > 0 do
					local from = playerMoList[toposition + 1]
					local to = nil
					while not to and toposition > 0 do -- Ensures that if somehow the list has any gaps we skip over them, and prevent infinite looping
						to = playerMoList[toposition]
						toposition = $-1
					end
					if to and from then 
						pdis = $ + FixedHypot(FixedHypot(from.x/4 - to.x/4, from.y/4 - to.y/4), from.z/4 - to.z/4)
						if toposition+1 == p.kartstuff[k_position] then
							local ahead  = FixedHypot(FixedHypot(from.x/4 - to.x/4, from.y/4 - to.y/4), from.z/4 - to.z/4)*4
							to = playerMoList[toposition+2]
							if to then
								local behind = FixedHypot(FixedHypot(from.x/4 - to.x/4, from.y/4 - to.y/4), from.z/4 - to.z/4)*4
							end
						end
					end
				end	
				pdis = ($ / mapobjectscale)*2
				pdis = ((130 + 8 - min(FZeroKart.PlayerCount(), 16)) * $) / 130
			end
			local sbgain = pdis/50
			--print("Super Boost gained: "..sbgain)
			FZeroKart.GainSuperBoost(p, sbgain)
		end
	end
	
	--Death timer
	if p.fzerokart.death_timer and p.fzerokart.death_timer < 7 then
		p.fzerokart.death_timer = $ + 1
		if p.playerstate == PST_DEAD then
			p.fzerokart.death_timer = 7
		end
	elseif p.fzerokart.death_timer == 7 then
		FZeroKart.KillPlayer(p)
		S_StartSound(nil, sfx_fzreti, p)
		p.fzerokart.death_timer = $ + 1
	end
	------------------------------------------------
	
	if p.pflags & PF_TIMEOVER then return end
	
	-- Wall Bump damage
	if (p.mo.eflags & MFE_JUSTBOUNCEDWALL)
	and FZeroKart.ShouldHurt(p)
	and p.playerstate == PST_LIVE then
		local wt = min(p.kartweight, 9)
		local spd = min(p.kartspeed, 9)
		local defense = ((26*4 + (spd - 1) + wt*2)*8)

		local base_dmg = FixedInt(FixedMul(p.speed, FRACUNIT*2))
		local bonus_dmg = FixedDiv(FixedMul(p.speed, FRACUNIT*4), 5*FRACUNIT)
		local total_dmg = base_dmg + FixedInt(FixedMul(FixedDiv(bonus_dmg, 192*FRACUNIT), (1040-defense)*FRACUNIT))

		/*
		if p.kartstuff[k_sneakertimer] then
			total_dmg = $/2 --damage you less during sneaker state
		end
		*/

		FZeroKart.DamagePlayer(p, total_dmg, {{"A wall", 0}, {"K_HSWALL", 0}}, false, p.fzerokart.energy > 1 and true or false)
		p.powers[pw_flashing] = TICRATE/2
		--print("HP Remaining: "..p.fzerokart.energy)
	end

	-- POWER DOWN state
	if p.fzerokart.energy == 1
	and not p.fzerokart.death_timer then
		p.kartstuff[k_boostpower] = min($, 4*FRACUNIT/5)
		local smoke
		local travelangle = p.frameangle
		if leveltime%3 == 0 then
			for i = 0, 1 do
				
				local L_Or_R = (i & 1) and -1 or 1
				local newx = p.mo.x + P_ReturnThrustX(p.mo, travelangle + (L_Or_R * ANGLE_135), FixedMul(32*FRACUNIT, p.mo.scale))
				
				local newy = p.mo.y + P_ReturnThrustY(p.mo, travelangle + (L_Or_R * ANGLE_135), FixedMul(32*FRACUNIT, p.mo.scale))
	
				smoke = P_SpawnMobj(newx, newy, p.mo.z, MT_SMOKE)
				smoke.target = p.mo
				smoke.fzero = true
				smoke.state = S_FZSLOWSMOKE1
				smoke.scale = p.mo.scale
				smoke.momz = 6*p.mo.scale
				smoke.destscale = p.mo.scale*2
				smoke.scalespeed = p.mo.scale/24
				smoke.fuse = TICRATE/3
			end
		end
	end
	
	p.lastspeed = p.speed
	p.fzerokart.lastspeed = p.kartspeed
	p.fzerokart.lastweight = p.kartweight
	p.fzerokart.lastskin = p.mo.skin
end
--addHook("PlayerThink", FZeroKart.PlayerThink)

states[S_BOOSTFLAME] = {SPR_BOST, FF_FULLBRIGHT|FF_ANIMATE, TICRATE*9999, nil, 6, 1, S_BOOSTFLAME}
addHook("MobjThinker", function (mo)
	if not (mo and mo.valid) then return end
	if not FZeroKart.Active.value then return end
	 
	if not (mo.target and mo.target.valid and mo.target.player) then return end
	mo.target.resetboostflame = false -- we already have one
	
	local p = mo.target.player
	local timer = p.kartstuff[k_sneakertimer]
	
	if mo.state == S_BOOSTFLAME and timer <= TICRATE/3 then
		mo.state = S_BOOSTSMOKESPAWNER
	elseif mo.state == S_BOOSTSMOKESPAWNER and timer > TICRATE/3 then
		mo.state = S_BOOSTFLAME
	end

	if mo.state == S_BOOSTFLAME then
		if not mo.target.player then return end
		if not (p.fzerokart.super_booston or p.fzerokart.boost_on) then return end
		
		mo.colorized = true
		if p.fzerokart.super_booston then
			mo.color = SKINCOLOR_WHITE
		elseif p.fzerokart.boost_on
			mo.color = SKINCOLOR_JAWZ
		end
	end
end, MT_BOOSTFLAME)

addHook("MobjThinker", function(mo)
	if not FZeroKart.Active.value then return end
	if not (mo and mo.valid) then return end
	if not (mo.target and mo.target.valid and mo.target.player) then return end
	
	local p = mo.target.player
	
	if not (p.fzerokart.super_booston or p.fzerokart.boost_on) then return end
		
	mo.colorized = true
	if p.fzerokart.super_booston then
		mo.color = SKINCOLOR_WHITE
	elseif p.fzerokart.boost_on
		mo.color = SKINCOLOR_JAWZ
	end
	
end, MT_SNEAKERTRAIL)

addHook("MobjThinker", function(mo)
	if not FZeroKart.Active.value then return end
	 
	if not (mo and mo.valid) then return end
	if mo.fzero and mo.target and mo.target.valid then
		if P_IsObjectOnGround(mo.target) then
			P_MoveOrigin(mo, mo.x + mo.target.momx, mo.y + mo.target.momy, mo.z + (mo.target.z - mo.target.player.fzerokart.lastz))
		else
			P_MoveOrigin(mo, mo.x + mo.target.momx, mo.y + mo.target.momy, mo.z + mo.target.momz)
		end
	else 
		return
	end
end, MT_SMOKE)

addHook("MobjThinker", function (mo)
	if not (mo and mo.valid) then return end
	if not (mo.target and mo.target.valid) then return end
	if mo.fzeroheal then
		if P_IsObjectOnGround(mo.target) then
			P_MoveOrigin(mo, mo.x + mo.target.momx, mo.y + mo.target.momy, mo.z +(mo.target.z - mo.target.player.fzerokart.lastz))
		else
			P_MoveOrigin(mo, mo.x + mo.target.momx, mo.y + mo.target.momy, mo.z + mo.target.momz)
		end
	end
	
	if mo.fzero or mo.fzeroheal then
		mo.colorized = true
		mo.color = SKINCOLOR_GREEN
	end
end, MT_DEZLASER)

addHook("MobjThinker", function(mo)
	if not FZeroKart.Active.value then return end
	
	if leveltime > 1 then
		P_RemoveMobj(mo)
	end
end, MT_BATTLEBUMPER)

FZeroKart.GameThink = function()
	if not FZeroKart.Active.value then return end
	
	if leveltime < 1 then return end
	if leveltime == 1 then FZeroKart.GameRefresh() end
	
	local randx, randy = P_RandomRange(-128,128), P_RandomRange(-128,128)

	if edt 
	and leveltime >=236 then -- You're all dead, good fucking job
		if edt == 1 then
			S_StopMusic()
		elseif edt == (TICRATE*1)+(TICRATE/2) then
			S_ChangeMusic("GOVER", false, nil)
		elseif edt > (TICRATE*5) then
			S_ChangeMusic("KRFAIL", true, nil, 0, 3*MUSICRATE)
			G_ExitLevel()
			edt = 0
			return
		end
		edt = $+1
		return
	else
		edt = 0 -- FUCKING HELL.
	end
	
	for p in players.iterate
		if not (p and p.valid) then continue end
		FZeroKart.PlayerThink(p)
	end

	if #FZeroKart.deadPlayers then
		local deltWith = {}
		for i, k in ipairs(FZeroKart.deadPlayers) do
			local p = k[1]
			local source = k[2]
			if type(source) == "table" then continue end
			if p and p.valid and ((p.pflags & PF_TIMEOVER) or p.fzerokart.death_timer) then continue end --dont heal if they are already dead :(
			if deltWith[p] then continue end -- we already delt with this player, skip
			if source and source.valid then
				if source.fzerokart and not source.fzerokart.death_timer and p ~= source then --dont heal if you killed yourself!
					local wt = source.kartweight
					local spd = source.kartspeed
	
					local fuel_econ = ((26*4 + (spd - 1) + wt*2)*8)
					local killbonus = fuel_econ/5
					source.fzerokart.kills = $ + 1
					source.fzerokart.energy = min(source.fzerokart.energy_max + (killbonus*source.fzerokart.kills), source.fzerokart.energy_max*2)
					deltWith[p] = true -- mark that this player was delt with
					if source and not source.spectator and source.mo then
						P_PlayVictorySound(source.mo)
						local exitsign = P_SpawnMobj(p.mo.x+(randx*mapobjectscale), p.mo.y+(randy*mapobjectscale), p.mo.z+(mapobjectscale*400),MT_SIGN)
						exitsign.target = source.mo
						exitsign.state = S_SIGN1
						exitsign.movefactor = p.mo.floorz
						exitsign.movecount = 1
					end
				end
			else
				k[2] = nil
			end
		end

		for i, k in ipairs(FZeroKart.deadPlayers) do
			--deal with each death here instead
			local p, source, damage, force = unpack(k, 1, 4)

			if not (p and p.valid and p.fzerokart) then continue end
			if p.pflags & PF_TIMEOVER then continue end --dont kill someone twice
			if p.fzerokart.death_timer then continue end --dont kill someone twice

			--lololol no u
			if p.spectator then continue end

			if damage >= p.fzerokart.energy or force then
				p.fzerokart.energy = 0
			else
				--they where saved from death!
				continue
			end

			if hitfeed then --snu why you gotta make it so hard to make a custom HF now :(
				local v = FZeroKart.HitfeedInfo(p)
				local s = {{}, {}}
				if type(source) == "table" then --they sent in a custom text
					s = source
				elseif source then --there is a source
					s = FZeroKart.HitfeedInfo(source)
				end

				HF_SendHitMessage(s, v, "K_HMEXPL") --HITFEED HAS A BUILD-IN EXPLODE ICON! v2 doesent (f) also thx snu
			else
				print(p.name .. " retired!")
			end

			p.fzerokart.death_timer = 1
		end

		FZeroKart.deadPlayers = {}
	end

	do
		local aliveCount = 0
		local winner = nil
		local pInGame = 0
		for p in players.iterate do
			if not (p and p.valid) then continue end
			if p.spectator then continue end
			pInGame = $+1
			if p.pflags & PF_TIMEOVER then
				continue
			else
				aliveCount = $+1
				winner = p
				if aliveCount > 1 then break end
			end
		end

		if aliveCount == 0 and pInGame
		and leveltime >= 236 then
			edt = 1
		elseif aliveCount == 1 and pInGame > 1 then --someone won by being last standing, exitlevel
			for p in players.iterate do
				if not (p and p.valid) then continue end
				if p.spectator then continue end
				if p == winner then
					p.kartstuff[k_position] = 1 -- Force this so losing lines don't play
					P_DoPlayerExit(winner)
					S_ChangeMusic("KRWIN", true, p)
				else
					S_ChangeMusic("KRFAIL", true, p)
				end
			end
		end
	end
end
addHook("ThinkFrame", FZeroKart.GameThink)

FZeroKart.PostThink = function()
	if leveltime == 0 then return end
	if not FZeroKart.Active.value then return end
	
	for p in players.iterate
		if not (p.mo and p.mo.valid) or p.spectator then continue end
		if not p.fzerokart then continue end

		local wt = p.kartweight
		local spd = p.kartspeed
	
		local fuel_econ = ((26*4 + (spd - 1) + wt*2)*8)
		local killbonus = fuel_econ/5

		local enmax = p.fzerokart.energy_max + (killbonus*p.fzerokart.kills)
		
		if p.fzerokart.energy_lag < p.fzerokart.energy then
			p.fzerokart.energy_lag = min($ + 8, p.fzerokart.energy)
		elseif p.fzerokart.energy_lag > p.fzerokart.energy then
			p.fzerokart.energy_lag = max($ - 10, p.fzerokart.energy)
		end
	end
end
addHook("PostThinkFrame", FZeroKart.PostThink)