-- Yes, this is literally BikeMod; figured the handling model works for what I'm
-- looking for

local ORIG_FRICTION = 62914

local id_outtable = { -- Outside Drift Angles
	[1] = 60, -- 94
	[2] = 78, -- 115
	[3] = 96, -- 136
	[4] = 114, -- 157
	[5] = 132, -- 178
	[6] = 150, -- 199
	[7] = 168, -- 220
	[8] = 186, -- 241
	[9] = 204 -- 262
}

local id_intable = { -- Inside Drift Angles
	[1] = 108, -- 84
	[2] = 102, -- 80
	[3] = 96, -- 77
	[4] = 90, -- 73
	[5] = 84, -- 70
	[6] = 78, -- 66
	[7] = 72, -- 63
	[8] = 66, -- 59
	[9] = 60  -- 56
}

addHook("MobjThinker", function (mo)
	if not (mo and mo.valid and mo.player) then return end
	if not FZeroKart.Active.value then return end
	 
	local p = mo.player
	local pks = p.kartstuff
	local wt = p.kartweight
	local iangle = id_intable[p.kartweight]
	local oangle = id_outtable[p.kartweight]
	--p.kartstuff[k_driftcharge] = 0
	local fricmod = 384
	
	if gamespeed == 2 then
		fricmod = 320
	end
	
	if p.cmd.buttons & (BT_BRAKE|~BT_ACCELERATE) then
		fricmod = $/2
	end
	
	if p.kartstuff[k_offroad] <= FRACUNIT/2
		mo.friction = max($, min(ORIG_FRICTION + (fricmod*(5 - wt)), FRACUNIT))
		--mo.friction = FRACUNIT
	end
	
	if leveltime >= 236 then
		if pks[k_drift] > 0 then -- Left Drift
			if p.speed >= 10*mo.scale
			and P_IsObjectOnGround(mo)
			and not (p.pflags & PF_TIMEOVER) then
				if p.cmd.driftturn < 0 then
					P_Thrust(mo, mo.angle - oangle*ANG1, FixedMul(p.speed/23, ((K_GetKartDriftSparkValue(p))*65) - mo.friction))
				elseif p.cmd.driftturn >= 0 then
					P_Thrust(mo, mo.angle + iangle*ANG1, FixedMul(p.speed/18, ((K_GetKartDriftSparkValue(p))*75) - mo.friction))
					if p.speed < 29*mo.scale and p.speed >= 22*mo.scale and (p.cmd.buttons & BT_ACCELERATE|~BT_BRAKE) and not pks[k_offroad] then
						P_Thrust(mo, mo.angle, 2*mo.scale/3)
					end
				end
			end
		elseif pks[k_drift] < 0 then -- Right Drift
			if p.speed >= 10*mo.scale
			and P_IsObjectOnGround(mo)
			and not (p.pflags & PF_TIMEOVER) then
				if p.cmd.driftturn > 0 then
					P_Thrust(mo, mo.angle + oangle*ANG1, FixedMul(p.speed/23, ((K_GetKartDriftSparkValue(p))*65) - mo.friction))
				elseif p.cmd.driftturn <= 0 then
					P_Thrust(mo, mo.angle - iangle*ANG1, FixedMul(p.speed/18, ((K_GetKartDriftSparkValue(p))*75) - mo.friction))
					if p.speed < 29*mo.scale and p.speed >= 22*mo.scale and (p.cmd.buttons & BT_ACCELERATE|~BT_BRAKE) and not pks[k_offroad] then
						P_Thrust(mo, mo.angle, 2*mo.scale/3)
					end
				end
			end
		end
		
		-- Without this, Bike sliptiding would be useless since it would default 
		-- to Kart's default sliptide turning radius, which is actually larger 
		-- than Bike's drift radius. Thank you Ridge Turnpike for making me 
		-- realize this.
		local slipangle = id_intable[max(10 - p.kartweight, 1)]
		if pks[k_aizdriftstrat] and not pks[k_drift]
			if pks[k_aizdriftstrat] > 0 then -- Left Sliptide
				P_Thrust(mo, mo.angle + slipangle*ANG1, FixedMul(p.speed/30, (FRACUNIT) - mo.friction))
			elseif pks[k_aizdriftstrat] < 0 -- Right Sliptide
				P_Thrust(mo, mo.angle - slipangle*ANG1, FixedMul(p.speed/30, (FRACUNIT) - mo.friction))
			end
		end
	end
	
end, MT_PLAYER)