/*
local function drawLine(v, x, y, t, angle, length, color)
    for i=0, length-1 do
        v.drawFill(x + FixedMul(i, cos(angle)), y - FixedMul(i, sin(angle)), t, t, color)
    end
end
*/
local retirelen = nil
local retirestr = "RETIRED"
local function barWidth(percent, maximum, full_length)
	return FixedInt(FixedRound(FixedDiv(min(percent,maximum) * FRACUNIT,maximum * FRACUNIT) * full_length))
end

local bars = {}
/**
 * OH MY GOD I AM HAVING TO WRITE JAVADOCS FOR A SINGLE FUNCTION LMAO
 * x - X position
 * y - Y position
 * value - current value to display
 * maxvalue - the max value can be
 * maxlength - how long bar is at maxvalue
 * bartype - the gfx prefix said bar uses (FZBHP / FZSPR / FZSHP)
 * offset - used for diagonal bars, use to either smush gfx together or spread them apart
 * color - the SKINCOLOR_ constant of the bar
 */
local function drawEnergyBar(v, x, y, value, maxvalue, maxlength, bartype, offset, flags, color)
	if not bars[bartype] then
		bars[bartype] = {}
		local i = 64
		while i do
			bars[bartype][i] = v.cachePatch(bartype..i)
			i = ($ / 2) or 0
		end
	end
	
	local calc_percent = barWidth(value, maxvalue, maxlength)
	local xoff = 0
	local s = 1
	while calc_percent ~= 0 do
		local bit = calc_percent&s
		calc_percent = $&!s
		if bit then
			v.draw(x + 1 + xoff, y, bars[bartype][bit], flags, v.getColormap(0, color))
			xoff = $+(bars[bartype][bit].width) + offset
		end
		s = $<<1
	end
end

local function fzero_energy(v, p, c)
	if not retirelen then
		retirelen = 0
		for i = 1, retirestr:len() do
			local let = retirestr:sub(i, i)
			local patch = v.cachePatch(string.format("MKFNT%03d", let:byte()))
			retirelen = $+patch.width
		end
	end

	if not FZeroKart.Active.value or server.SPBArunning then
		hud.enable("item")
		hud.enable("gametypeinfo")
		if G_BattleGametype() then
			hud.enable("battlerankingsbumpers")
		end
		return
	end
	hud.disable("item")
	if G_BattleGametype() then
		hud.disable("battlerankingsbumpers")
		hud.disable("gametypeinfo")
	end
	if not (p.mo and p.mo.valid) return end
	
	local centerx
	local centery
	local baseXoffset, baseYoffset = 4, 5
	local baseX, baseY
	local flags = V_HUDTRANS
	local prefix = "FZB"
	
	local brXoffset, brYoffset
		
	local hpX, hpY, hpMax, hpBarOffset
	local bstX, bstY, bstMax
	
	if not (p and p.valid and not p.spectator) then return end
	if not p.fzerokart then return end
	if splitscreen <= 1
		local splitscreen_calc = ((splitscreen + 1) % 2)+ 1
		-- If SinglePlayer -- 2
		-- If Splitscreen -- 1
		baseX = baseXoffset * 2
		baseY = (splitscreen_calc * (p.splitscreenindex + 1) * 100) - (baseYoffset * splitscreen_calc)
		flags = $|V_SNAPTOLEFT|((splitscreen_calc * (p.splitscreenindex + 1) - 1) and V_SNAPTOBOTTOM)
		centerx = 160
		centery = (splitscreen_calc * (p.splitscreenindex + 1) * 50) + (p.splitscreenindex * 50)
		
		brXoffset, brYoffset = 22, -25
		hpX, hpY, hpMax, hpBarOffset = 70, baseY - 20, 100, -4
		bstX, bstY, bstMax = 30, baseY - 24, 100
		
	elseif splitscreen >= 2
		//baseX = baseXoffset + (100 * (p.splitscreenindex % 2))
		baseY = (p.splitscreenindex + 1) * 50
		-- RIGHT OR LEFT
		if p.splitscreenindex % 2 == 1 then
			baseX = 320 - (baseXoffset / 2) - 97
			flags = $|V_SNAPTORIGHT
			centerx = 240
		else
			baseX = baseXoffset / 2
			flags = $|V_SNAPTOLEFT
			centerx = 80
		end
		--TOP OR BOTTOM
		if p.splitscreenindex <= 1 then
			baseY = baseYoffset / 2
			flags = $|V_SNAPTOTOP
			centery = 50
		else
			baseY = (baseYoffset / 2) + 100
			centery = 150
		end
		flags = $
		prefix = "FZS"
		
		brXoffset, brYoffset = 12, 0
		hpX, hpY, hpMax, hpBarOffset = baseX+brXoffset+31, baseY + 5, 50, -1
		bstX, bstY, bstMax = baseX+brXoffset, baseY + 1, 50
	end
	v.draw(baseX+brXoffset, baseY+brYoffset, v.cachePatch(prefix.."BR"), flags, v.getColormap(TC_DEFAULT, p.skincolor))
	
	if p.pflags & PF_TIMEOVER then
		v.drawKartString(centerx-(retirelen/2), centery-6, retirestr, V_HUDTRANS)
	end

	--Standard health and anims
	local hp_color = SKINCOLOR_EMERALD
	
	if not p.fzboost then
		hp_color = SKINCOLOR_GREY
	end
	
	if p.fzerokart.energy < 301 and leveltime%TICRATE > (TICRATE/2) then 
		hp_color = SKINCOLOR_KETCHUP 
	end
	drawEnergyBar(v, hpX, hpY, p.fzerokart.energy, p.fzerokart.energy_max, hpMax, prefix.."HP", hpBarOffset, flags, hp_color)
	
	
	local lag_check = min(p.fzerokart.energy, p.fzerokart.energy_max)
	if p.fzerokart.energy_lag != lag_check then
		local net_lag = min(p.fzerokart.energy_lag, p.fzerokart.energy_max) - lag_check
		local lag_begin = hpX + min(barWidth(p.fzerokart.energy,p.fzerokart.energy_max,hpMax), hpMax)
		local lag_color = SKINCOLOR_CRIMSON
		if p.fzerokart.energy_lag < lag_check
			lag_begin = $ - barWidth(abs(net_lag), p.fzerokart.energy_max, hpMax)
			lag_color = SKINCOLOR_LIME
		end
		drawEnergyBar(v, lag_begin, hpY, abs(net_lag), p.fzerokart.energy_max, hpMax, prefix.."HP", hpBarOffset, flags, lag_color)
	end

	--Bonus Health and lag anims
	local bonus_energy = max(p.fzerokart.energy - p.fzerokart.energy_max, 0)
	drawEnergyBar(v, hpX, hpY, bonus_energy, p.fzerokart.energy_max, hpMax, prefix.."HP", hpBarOffset, flags, SKINCOLOR_JAWZ)
	local bonus_lag_check = max(p.fzerokart.energy, p.fzerokart.energy_max)
	if bonus_lag_check != p.fzerokart.energy_lag then
		local net_lag = max(p.fzerokart.energy_lag,p.fzerokart.energy_max) - bonus_lag_check
		local lag_begin = hpX + min(barWidth(bonus_energy, p.fzerokart.energy_max, hpMax), hpMax)
		local lag_color = SKINCOLOR_CRIMSON
		if  p.fzerokart.energy_lag < bonus_lag_check then
			lag_begin = $ - barWidth(abs(net_lag), p.fzerokart.energy_max, hpMax)
			lag_color = SKINCOLOR_CYAN
		end
		drawEnergyBar(v, lag_begin, hpY, abs(net_lag), p.fzerokart.energy_max, hpMax, prefix.."HP", hpBarOffset, flags, lag_color)
	end
	
	---------------------------------------
	
	-- Super Boost Display
	-- SECONDCOLOR SUPPORT
	local alt_color = ColorOpposite(p.skincolor)
	if (kart_secondcolors) and p.ksc_colors then
		alt_color = (p.ksc_colors.customizable and p.ksc_secondcolor) or
					 p.ksc_colors[p.skincolor] or ColorOpposite(p.skincolor)
	end
	
	local sbbar = alt_color
	
	if leveltime%TICRATE/2 > TICRATE/4
	and p.fzerokart.super_boost == FZeroKart.SuperBoostMax then
		sbbar = p.skincolor
	end

	drawEnergyBar(v, bstX, bstY, p.fzerokart.super_boost, FZeroKart.SuperBoostMax, bstMax, "FZSPR", -2, flags, sbbar)
	
	
	if FZeroKart.HudText.value and splitscreen <= 1 then
		v.drawString(hpX+6, hpY+1, "EN: "..p.fzerokart.energy, flags)
		v.drawString(bstX+4,bstY-6,"BST: "..p.fzerokart.super_boost, flags)
	end
	
	/*
	if p.kartstuff[k_lapanimation] then
		print("Timer: "..p.kartstuff[k_lapanimation])
	end
	*/
	if splitscreen <= 1 then
		hud.disable("gametypeinfo")
		if (p.laps and p.laps == numlaps) then
			v.drawString(hpX-31,hpY+3,"FIN", flags)
		else
			local lapnum = string.format("%02i", p.laps and p.laps + 1 or 1)
			local maplap = string.format("%02i", CV_FindVar("numlaps").value)
			
			if p.kartstuff[k_lapanimation]
			and (leveltime%7 > 3)
				local posmap
				
				if p.kartstuff[k_position] == 1 then
					posmap = V_BLUEMAP
				elseif p.kartstuff[k_position] > 1
				and not K_IsPlayerLosing(p) then
					posmap = V_GREENMAP
				else
					posmap = V_REDMAP
				end
				
				v.drawString(hpX-31,hpY+3, lapnum.."/"..maplap, flags|posmap, "thin")
			else
				v.drawString(hpX-31,hpY+3, lapnum.."/"..maplap, flags, "thin")
			end
		end
	else
		if G_RaceGametype() then
			hud.enable("gametypeinfo")
		end
	end
end
hud.add(fzero_energy, "game")

local use_cooldown = 105
local function fzero_spin(v,p,c)
	if not (p.mo and p.mo.valid) return end
	local baseXoffset,baseYoffset = 4,5
	local baseX,baseY
	local flags = V_HUDTRANS
	local prefix = "FZBSP"
	
	local spXoffset,spYoffset
		
	if splitscreen <= 1
		local splitscreen_calc = ((splitscreen + 1) % 2)+ 1
		-- If SinglePlayer -- 2
		-- If Splitscreen -- 1
		baseX = baseXoffset * 2
		baseY = (splitscreen_calc * (p.splitscreenindex + 1) * 100) - (baseYoffset * splitscreen_calc)
		flags = $|V_SNAPTOLEFT|((splitscreen_calc * (p.splitscreenindex + 1) - 1) and V_SNAPTOBOTTOM)
		spXoffset,spYoffset =  0, -29
		
	elseif splitscreen >= 2
		prefix = "FZSSP"
		-- LEFT OR RIGHT
		if p.splitscreenindex % 2 == 1 then
			baseX = 320 - (baseXoffset / 2) - 97
			flags = $|V_SNAPTORIGHT
		else
			baseX = baseXoffset / 2
			flags = $|V_SNAPTOLEFT
		end
		--TOP OR BOTTOM
		if p.splitscreenindex <= 1 then
			baseY = baseYoffset / 2
			flags = $|V_SNAPTOTOP
		else
			baseY = (baseYoffset / 2) + 100
		end
		flags = $
		spXoffset,spYoffset =  -1, -1
	end

	v.draw(baseX+spXoffset,baseY+spYoffset, v.cachePatch(prefix.."BRD"), flags, v.getColormap(TC_DEFAULT, p.skincolor))
	
	local disabledbox = (p.playerstate == 1 or p.playerstate == 2 or p.kartstuff[k_spinouttimer] or p.kartstuff[k_respawn])
	
	local suffix = "GRY"
	-- SECONDCOLOR SUPPORT
	local alt_color = ColorOpposite(p.skincolor)
	if (kart_secondcolors) and p.ksc_colors then
		alt_color = (p.ksc_colors.customizable and p.ksc_secondcolor) or
					 p.ksc_colors[p.skincolor] or ColorOpposite(p.skincolor)
	end
	
	local color = v.getColormap(TC_DEFAULT, alt_color)
	if p.nspincooldown then
		if p.nspincooldown > use_cooldown then
			suffix = "GRY"
		else
			suffix = "CR"..(6-(p.nspincooldown*6/use_cooldown))
			if suffix == "CR0" then
				suffix = "GRY"
			end
		end
	else
		if p.nspinicontimer and p.nspinicontimer % 3 then
			suffix = "FLS"
		end
		if disabledbox then
			if p.nspinicontimer then
				suffix = "GRY"
			else
				suffix = "LCK"
			end
		else
			if not p.nspinicontimer then
				suffix = "USE"
			end
		end
	end
	
	
	local hudicon = prefix..suffix
	
	v.draw(baseX+spXoffset,baseY+spYoffset, v.cachePatch(hudicon), flags, color)
	
end
hud.add(fzero_spin, "game")

local function fzero_speedometer(v,p,c)
	if not FZeroKart.Active.value or server.SPBArunning then
		hud.enable("speedometer")
		return
	end
	hud.disable("speedometer")
	if splitscreen then return end
	if not (p.mo and p.mo.valid) return end
	
	local speed = CV_FindVar("kartdisplayspeed")
	if speed.value == 0 then return end
	local dispSpeed = FixedDiv(p.speed, FixedMul(K_GetKartSpeed(p, false), 62914))*100>>FRACBITS
	local convSpeed
	local unit
	
	-- KILOMETERS PER HOUR
	if speed.value == 1
		convSpeed = FixedDiv(FixedMul(p.speed, 142371), mapheaderinfo[gamemap].mobj_scale)/FRACUNIT
		unit = "km/h"
	-- MILES PER HOUR
	elseif speed.value == 2
		convSpeed = FixedDiv(FixedMul(p.speed, 88465), mapheaderinfo[gamemap].mobj_scale)/FRACUNIT
		unit = "mph"
	-- FRACUNIT PER TIC
	elseif speed.value == 3
		convSpeed = FixedDiv(p.speed, mapheaderinfo[gamemap].mobj_scale)/FRACUNIT
		unit = "Fu/t"
	-- PERCENT
	elseif speed.value == 4 and p.mo
		convSpeed = dispSpeed
		unit = "%"
	end
	
	//dispSpeed = ($ * ANG1)
	//drawLine(v,100,100,2,(-1*dispSpeed)+ANGLE_180,20,0)
	v.drawString(33, 150, convSpeed.." "..unit, V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS, "left")
end

hud.add(fzero_speedometer, "game")