-- Sector Plus
-- Because we need to replicate the Skyway mechanic as much as possible
local function MobjFlipped(mo)
	return P_MobjFlip(mo) < 0
end
local function InSectorSpecial(mo, section, special)
	local fofsector = P_ThingOnSpecial3DFloor(mo)
	-- You can be inside a FoF without being grounded
	if fofsector then
		--print("fofsector "..(fofsector and "yes" or "no"))
		if GetSecSpecial(fofsector.special,section) == special then
			--print("has special "..section.." "..special)
			return fofsector
		end
	end
	if GetSecSpecial(mo.subsector.sector.special, section) == special then
		local flipped = MobjFlipped(mo)
		local slope = flipped and mo.subsector.sector.c_slope or mo.subsector.sector.f_slope -- no FoF
		local savedz = mo.z
		mo.z = mo.z -- update flooz/ceilingz, since they won't match properly for this tic yet
		local savedplanez = flipped and mo.ceilingz or mo.floorz -- current position floorz/ceilingz
		mo.flags = $|MF_NOCLIPHEIGHT -- we need to noclip it to make sure a bordering sector/fof doesnt mess with the floorz/ceilingz checking
		mo.z = slope and P_FloorzAtPos(mo.x, mo.y, mo.z, mo.height) or flipped and mo.subsector.sector.ceilingheight or mo.subsector.sector.floorheight -- sets floorz and ceilingz using hardcode functions we can't access from here
		local notonfof = savedplanez == (flipped and mo.ceilingz or mo.floorz) -- if our actual z is the same as the calculated floorz/ceilingz for this sector's slope, we aren't on a FoF
		mo.flags = $ & ~MF_NOCLIPHEIGHT
		mo.z = savedz
		return notonfof and mo.subsector.sector or nil
	end
	return nil
end

FZeroKart.SectorPlus = function(mo)
	if not FZeroKart.Active.value then return end
	if not (mo and mo.valid) then return end
	local p = mo.player
	if not p.fzerokart then return end
	if not (p.fzerokart.super_booston) then
		return
	end

	-- Sneaker Boost
	if InSectorSpecial(mo, 4, 6) then
		p.kartstuff[k_floorboost] = 1
	end
	
	if InSectorSpecial(mo, 1, 9) then
		if not (mo.recharge) then
			mo.recharge = true
			S_StartSound(mo, sfx_fzchg)
		end
	end
end

addHook("MobjThinker", FZeroKart.SectorPlus, MT_PLAYER)